## Terminal

### Basic Usage (SSH)


```Python 

from tensorpc.dock import (marker, mui, terminal, plus)
from tensorpc.autossh import SSHConnDesc
class App:
    class Config(plus.AppInMemory.Config):
        is_horizontal = False
        height = "800px"

    @marker.mark_create_layout
    def my_layout(self):
        self._username = mui.Input("Username")
        self._password = mui.Input("Password")
        ssh_conn_desc = SSHConnDesc("localhost:22", self._username.value, self._password.value)

        term = terminal.AsyncSSHTerminal(ssh_conn_desc).prop(boxProps=mui.FlexBoxProps(flex=1))
        self._connect = mui.Button("Connect", callback=lambda: term.connect_with_new_desc(ssh_conn_desc))
        return mui.VBox([
            mui.HBox([
                self._username, mui.Divider(orientation="vertical"), self._password, mui.Divider(orientation="vertical"), self._connect
            ]),
            term,
        ]).prop(height="100%", width="100%")

```